package es.ua.jtech.spring.mvc;



import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.validation.BindingResult;
import org.springframework.validation.ObjectError;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import es.ua.jtech.spring.negocio.ICocheBO;
import es.ua.jtech.spring.modelo.Coche;

/**
 *
 * @author especialista
 */
@Controller
public class CocheController {

    @Autowired
    ICocheBO bo;


    /*---------------------- LISTAR TODOS LOS COCHES  -----------------------------------------*/
    @RequestMapping("/listar.do")
    public String listar(Model modelo) {
        modelo.addAttribute("listado", bo.listar());
        return "listar";
    }

    /*---------------------- ACTUALIZAR COCHE  -----------------------------------------*/
    @RequestMapping(value = "/editar.do", method = RequestMethod.GET)
    public String prepararEditar(Model modelo, @RequestParam(value = "matricula") String matricula) {
        modelo.addAttribute(bo.obtener(matricula));
        return "editar";
    }

    @RequestMapping(value = "/editar.do", method = RequestMethod.POST)
    public String procesarEditar(Coche coche, BindingResult result, Model modelo) {
        if (result.hasErrors()) {
            return "editar";
        } else {
            bo.actualizar(coche);
            return "redirect:listar.do";
        }
    }

    /*-----------------------INSERTAR NUEVO COCHE -------------------------------------*/
    @RequestMapping(value = "/crear.do", method = RequestMethod.GET)
    public String prepararCrear(Model modelo) {
        modelo.addAttribute(new Coche());
        return "crear";
    }

    @RequestMapping(value = "/crear.do", method = RequestMethod.POST)
    public String procesarCrear(Coche coche, BindingResult result, Model modelo) {
        if (result.hasErrors()) {
        	for (ObjectError error : result.getAllErrors()) {
        		System.err.println(error.getDefaultMessage());
        	}
             return "crear";
        } else {
        	bo.crear(coche);
            return "redirect:listar.do";
        }
    }
}
